package com.example.application.data.entity;

import javax.persistence.*;
import java.util.Objects;

@Entity
@Table(name = "game", schema = "public", catalog = "chessleague")
public class Game {
    private Integer id;
    private Boolean player1IsWhite;
    private Integer result;
    private Match match;
    private GameInfo gameInfo;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Basic
    @Column(name = "player1_is_white", nullable = false)
    public Boolean getPlayer1IsWhite() {
        return player1IsWhite;
    }

    public void setPlayer1IsWhite(Boolean player1IsWhite) {
        this.player1IsWhite = player1IsWhite;
    }

    @Basic
    @Column(name = "result", nullable = false)
    public Integer getResult() {
        return result;
    }

    public void setResult(Integer result) {
        this.result = result;
    }
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Game that = (Game) o;
        return Objects.equals(id, that.id) && Objects.equals(player1IsWhite, that.player1IsWhite) && Objects.equals(result, that.result);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, player1IsWhite, result);
    }

    @ManyToOne(cascade=CascadeType.ALL)
    @JoinColumn(name = "match", referencedColumnName = "id", nullable = false)
    public Match getMatch() {
        return match;
    }

    public void setMatch(Match match) {
        this.match = match;
    }

    @OneToOne
    @JoinColumn(name = "info", referencedColumnName = "id")
    public GameInfo getGameInfo() {
        return gameInfo;
    }

    public void setGameInfo(GameInfo gameInfo) {
        this.gameInfo = gameInfo;
    }
}
