package com.example.application.data.entity;

import javax.persistence.*;
import java.util.Objects;

@Entity
@Table(name = "game_info", schema = "public", catalog = "chessleague")
public class GameInfo {
    private Integer id;
    private String url;
    private Game game;
    private Integer format;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Basic
    @Column(name = "url", length = -1)
    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    @Basic
    @Column(name = "format", nullable = false)
    public Integer getFormat() {
        return format;
    }

    public void setFormat(Integer format) {
        this.format = format;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        GameInfo that = (GameInfo) o;
        return Objects.equals(id, that.id) && Objects.equals(url, that.url) && Objects.equals(format, that.format);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, url, format);
    }

    @OneToOne(mappedBy = "gameInfo")
    public Game getGame() {
        return game;
    }

    public void setGame(Game game) {
        this.game = game;
    }
}
