package com.example.application.data.entity;

import javax.persistence.*;
import java.util.Collection;
import java.util.Objects;

@Entity
@Table(name = "season", schema = "public", catalog = "chessleague")
public class Season {
    private Integer id;
    private Integer yearStart;
    private Integer yearEnd;
    private Collection<Matchday> matchdays;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    @Basic
    @Column(name = "year_start", nullable = false)
    public Integer getYearStart() {
        return yearStart;
    }

    public void setYearStart(Integer yearStart) {
        this.yearStart = yearStart;
    }

    @Basic
    @Column(name = "year_end", nullable = false)
    public Integer getYearEnd() {
        return yearEnd;
    }

    public void setYearEnd(Integer yearEnd) {
        this.yearEnd = yearEnd;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Season that = (Season) o;
        return Objects.equals(id, that.id) && Objects.equals(yearStart, that.yearStart) && Objects.equals(yearEnd, that.yearEnd);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, yearStart, yearEnd);
    }

    @OneToMany(mappedBy = "season")
    public Collection<Matchday> getMatchdays() {
        return matchdays;
    }

    public void setMatchdays(Collection<Matchday> matchdays) {
        this.matchdays = matchdays;
    }

    @Override
    public String toString() {
        String s = yearStart.toString();
        if (!yearEnd.equals(yearStart)) {
            s += "/" + yearEnd.toString();
        }
        return s;
    }
}
