package com.example.application.data.service;

import com.example.application.data.entity.Matchday;
import com.example.application.data.entity.Season;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.vaadin.artur.helpers.CrudService;

import java.util.List;
import java.util.stream.Collectors;

@Service
public class MatchdayService extends CrudService<Matchday, Integer> {

    private final MatchdayRepository repository;

    public MatchdayService(@Autowired MatchdayRepository repository) {
        this.repository = repository;
    }

    @Override
    protected MatchdayRepository getRepository() {
        return repository;
    }

    public List<Matchday> getMatchdaysForSeason(Season season) {
        return repository.findAll().stream()
                .filter(matchday -> matchday.getSeason().equals(season))
                .collect(Collectors.toList());
    }
}
