package com.example.application.data.service;

import com.example.application.data.entity.Season;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.vaadin.artur.helpers.CrudService;

import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class SeasonService extends CrudService<Season, Integer> {

    private final SeasonRepository repository;

    public SeasonService(@Autowired SeasonRepository repository) {
        this.repository = repository;
    }

    @Override
    protected SeasonRepository getRepository() {
        return repository;
    }

    public List<Season> getAllSeasonsSorted() {
        return repository.findAll().stream()
                .sorted(Comparator.comparingInt(Season::getYearEnd))
                .sorted(Comparator.comparingInt(Season::getYearStart))
                .collect(Collectors.toList());
    }

}
